/* NiuTrans.Tensor - an open-source tensor library
 * Copyright (C) 2018, Natural Language Processing Lab, Northestern University.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
* $Created by: HU Chi (huchinlp@foxmail.com) 2019-03-18
*/

#include "StringUtil.h"

namespace nts {

/* split string by delimiter, this will return indices of all sub-strings */
vector<pair<int, int>> SplitToPos(const string& s, const string& delimiter)
{
    vector<pair<int, int>> fields;
    if (delimiter.length() == 0) {
        fields.emplace_back(0, s.length());
        return fields;
    }
    int pos = 0;
    int start = 0;
    while ((pos = s.find(delimiter, start)) != string::npos) {
        if (pos != start) {
            fields.emplace_back(start, pos);
        }
        start = pos + delimiter.length();
    }
    if (start != s.length()) {
        fields.emplace_back(start, s.length());
    }
    return fields;
}
}